'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = chain;

var _normalize = require('./normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Like a generic promise waterfall, but specifically for passing a file map
 * through a series of builder functions.
 *
 * Also normalizes the file map on the way in and out of every builder.
 */

function chain() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  // validate/normalize args
  var fns = args.filter(function (fn) {
    if (fn === undefined || fn === null) return false;

    if ((0, _lodash.isFunction)(fn)) return true;

    throw new TypeError('Every argument to chain() must be a function or null/undefined');
  });

  // return the chained builder
  return function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_files) {
      var files, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, fn;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              files = _files;
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 4;
              _iterator = (0, _getIterator3.default)(fns);

            case 6:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context.next = 15;
                break;
              }

              fn = _step.value;

              files = (0, _normalize2.default)(files);

              // call the next function
              _context.next = 11;
              return _promise2.default.resolve(fn(files));

            case 11:
              files = _context.sent;

            case 12:
              _iteratorNormalCompletion = true;
              _context.next = 6;
              break;

            case 15:
              _context.next = 21;
              break;

            case 17:
              _context.prev = 17;
              _context.t0 = _context['catch'](4);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 21:
              _context.prev = 21;
              _context.prev = 22;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 24:
              _context.prev = 24;

              if (!_didIteratorError) {
                _context.next = 27;
                break;
              }

              throw _iteratorError;

            case 27:
              return _context.finish(24);

            case 28:
              return _context.finish(21);

            case 29:
              return _context.abrupt('return', (0, _normalize2.default)(files));

            case 30:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[4, 17, 21, 29], [22,, 24, 28]]);
    }));

    function chainedBuilder(_x) {
      return ref.apply(this, arguments);
    }

    return chainedBuilder;
  }();
}
//# sourceMappingURL=chain.js.map