'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Directory = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * Recursively soft-removes empty directories. If a directory isn't empty, it
 * quietly gives up (this happens, eg, when a directory still contains some file
 * that the matcher excludes).
 */

var pruneEmptyAncestors = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(file, until) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(until === file || !(0, _subdir2.default)(until, file))) {
              _context.next = 2;
              break;
            }

            return _context.abrupt('return');

          case 2:

            file = _path2.default.dirname(file); // eslint-disable-line no-param-reassign

            _context.prev = 3;
            _context.next = 6;
            return _sander2.default.rmdir(file);

          case 6:
            _context.next = 13;
            break;

          case 8:
            _context.prev = 8;
            _context.t0 = _context['catch'](3);

            if (!(_context.t0.code === 'ENOTEMPTY' || _context.t0.code === 'ENOENT')) {
              _context.next = 12;
              break;
            }

            return _context.abrupt('return');

          case 12:
            throw _context.t0;

          case 13:
            _context.next = 15;
            return pruneEmptyAncestors(file, until);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 8]]);
  }));
  return function pruneEmptyAncestors(_x, _x2) {
    return ref.apply(this, arguments);
  };
}();

/**
 * Mutates the passed directory object by [re]priming its caches to match the real files on disk.
 */


var reprime = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(dir) {
    var _this = this;

    var files, mtimes, totalSize, load;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            // start the new files and mtimes caches (eventually to replace the ones on the object)
            files = {};
            mtimes = {};

            // define resursive function to load directory contents

            totalSize = 0;

            load = function load(dirName) {
              return _bluebird2.default.map(_sander2.default.readdir(dirName), function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_name) {
                  var name, relativeName, stat, diskMtime, lastKnownMtime, cachedContents, contents, mtime;
                  return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          name = _path2.default.resolve(dirName, _name);
                          relativeName = _path2.default.relative(dir._absolutePath, name);

                          // find out when the file last changed on disk

                          _context2.next = 4;
                          return _sander2.default.lstat(name);

                        case 4:
                          stat = _context2.sent;
                          diskMtime = stat.mtime.getTime();

                          // find out when our cached copy last changed (if any)

                          lastKnownMtime = dir._mtimes.get(relativeName);

                          if (!stat.isFile()) {
                            _context2.next = 29;
                            break;
                          }

                          if (dir._match(relativeName)) {
                            _context2.next = 10;
                            break;
                          }

                          return _context2.abrupt('return');

                        case 10:

                          // get the cached contents (if any)
                          cachedContents = dir._files.get(relativeName);

                          // decide what we're going to go with (the one from the cache or the one on disk)

                          contents = void 0;
                          mtime = void 0;
                          // console.log('\nfile', name);
                          // console.log('  lastKnownMtime', lastKnownMtime);
                          // console.log('       diskMtime', diskMtime);
                          // console.log();

                          if (!(cachedContents && diskMtime <= lastKnownMtime)) {
                            _context2.next = 18;
                            break;
                          }

                          // cached file exists and is new enough; use it
                          // console.log('cache hit!!', relativeName);
                          mtime = lastKnownMtime;
                          contents = cachedContents;
                          _context2.next = 22;
                          break;

                        case 18:
                          // no cached file (or too old); read the file from disk
                          // console.log('cache miss:', relativeName);
                          mtime = diskMtime;
                          _context2.next = 21;
                          return _sander2.default.readFile(name);

                        case 21:
                          contents = _context2.sent;

                        case 22:

                          // verify adding this file doesn't take us over the filesize limit
                          totalSize += contents.length;

                          if (!(totalSize > dir._limit)) {
                            _context2.next = 25;
                            break;
                          }

                          throw new Error('Contents of directory exceed ' + (0, _prettyBytes2.default)(dir._limit) + ' limit: ' + dir._absolutePath);

                        case 25:

                          // update the new caches with this file's contents and mtime
                          files[relativeName] = contents;
                          mtimes[relativeName] = mtime;
                          _context2.next = 35;
                          break;

                        case 29:
                          if (!stat.isDirectory()) {
                            _context2.next = 34;
                            break;
                          }

                          _context2.next = 32;
                          return load(name);

                        case 32:
                          _context2.next = 35;
                          break;

                        case 34:
                          throw new Error('Not a file or directory: ' + name);

                        case 35:
                        case 'end':
                          return _context2.stop();
                      }
                    }
                  }, _callee2, _this);
                }));
                return function (_x4) {
                  return ref.apply(this, arguments);
                };
              }());
            };

            // start recursive load


            _context3.prev = 4;
            _context3.next = 7;
            return load(dir._absolutePath);

          case 7:
            _context3.next = 17;
            break;

          case 9:
            _context3.prev = 9;
            _context3.t0 = _context3['catch'](4);

            if (!(_context3.t0.code === 'ENOENT' && _context3.t0.path === dir._absolutePath)) {
              _context3.next = 16;
              break;
            }

            _context3.next = 14;
            return _sander2.default.mkdir(dir._absolutePath);

          case 14:
            _context3.next = 17;
            break;

          case 16:
            throw _context3.t0;

          case 17:

            // save the new caches and note that the directory has been primed
            /* eslint-disable no-param-reassign */
            dir._files = _immutable2.default.Map(files);
            dir._mtimes = _immutable2.default.Map(mtimes);
            dir._primed = true;
            /* eslint-enable no-param-reassign */

          case 20:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[4, 9]]);
  }));
  return function reprime(_x3) {
    return ref.apply(this, arguments);
  };
}();

exports.default = directory;

var _connect = require('connect');

var _connect2 = _interopRequireDefault(_connect);

var _diff = require('./diff');

var _diff2 = _interopRequireDefault(_diff);

var _errorhandler = require('errorhandler');

var _errorhandler2 = _interopRequireDefault(_errorhandler);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _matcher = require('./matcher');

var _matcher2 = _interopRequireDefault(_matcher);

var _normalize = require('./normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _filesizeParser = require('filesize-parser');

var _filesizeParser2 = _interopRequireDefault(_filesizeParser);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _prettyBytes = require('pretty-bytes');

var _prettyBytes2 = _interopRequireDefault(_prettyBytes);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _sander = require('sander');

var _sander2 = _interopRequireDefault(_sander);

var _sane = require('sane');

var _sane2 = _interopRequireDefault(_sane);

var _serveIndex = require('serve-index');

var _serveIndex2 = _interopRequireDefault(_serveIndex);

var _serveStatic = require('serve-static');

var _serveStatic2 = _interopRequireDefault(_serveStatic);

var _subdir = require('subdir');

var _subdir2 = _interopRequireDefault(_subdir);

var _lodash = require('lodash');

var _portscannerPlus = require('portscanner-plus');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaults = {
  match: '**',
  limit: '10MB'
};

var queueableMethods = void 0;

/**
 * A Directory instance represents a real directory on disk and acts as an
 * in-memory cache of its entire contents.
 */

var Directory = exports.Directory = function () {
  function Directory(name, _options) {
    (0, _classCallCheck3.default)(this, Directory);

    var dir = this;

    var options = (0, _assign2.default)({}, defaults, _options);

    // settings
    dir._absolutePath = _path2.default.resolve(name);
    dir._match = (0, _matcher2.default)(options.match);
    dir._limit = Number((0, _filesizeParser2.default)(options.limit)); // https://github.com/patrickkettner/filesize-parser/pull/10

    if (options.force !== true && !(0, _subdir2.default)(process.cwd(), dir._absolutePath)) {
      throw new Error("exhibit: Cannot work outside CWD unless you enable the 'force' option");
    }

    // facts about temporal state
    dir._watcher = null; // sane watcher, if active
    dir._primed = false; // whether there's anything in the cache

    // intialise caches
    dir._files = _immutable2.default.Map(); // [fileName: contents]
    dir._mtimes = _immutable2.default.Map(); // [fileName: mtime]

    // add all the faux-decorated 'queueable' methods
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      var _loop = function _loop() {
        var methodName = _step.value;

        var method = queueableMethods[methodName];

        (0, _defineProperty2.default)(dir, methodName, {
          value: function value() {
            var args = arguments;

            dir._queuedOperations = _bluebird2.default.resolve(dir._queuedOperations).then(function () {
              return method.apply(dir, args);
            });

            return dir._queuedOperations;
          }
        });
      };

      for (var _iterator = (0, _getIterator3.default)((0, _keys2.default)(queueableMethods)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        _loop();
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  /**
   * Synchronous method to retrieve the files cache as it stands, without revalidating
   * against the disk. Throws if this directory has never been primed.
   */


  (0, _createClass3.default)(Directory, [{
    key: 'getCache',
    value: function getCache() {
      if (!this._primed) throw new Error('exhibit: Directory has never been primed.');
      return this._files;
    }
  }]);
  return Directory;
}();

// later, the following methods will be moved into the class definition and decorated
// with `@queuable`, but for now Babel v6 doesn't support decorators


queueableMethods = { // eslint-disable-line prefer-const

  /**
   * Reads the contents of the directory, recursively, but cached.
   */

  read: function read(incomingFiles) {
    var _this2 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
      var dir;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              dir = _this2; // until babel bugs resolved

              // return from cache immediately if we know this dir is being kept up to date

              if (!dir._watching) {
                _context4.next = 3;
                break;
              }

              return _context4.abrupt('return', dir._files);

            case 3:
              _context4.next = 5;
              return reprime(dir);

            case 5:
              if (!incomingFiles) {
                _context4.next = 7;
                break;
              }

              return _context4.abrupt('return', (0, _normalize2.default)(incomingFiles).merge(dir._files));

            case 7:
              return _context4.abrupt('return', dir._files);

            case 8:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this2);
    }))();
  },
  write: function write(incomingFiles) {
    var _this3 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
      var dir, patch, newFiles, newMtimes, deletions, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, deletion, files, mtimes;

      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              dir = _this3;

              if (!dir._watching) {
                _context6.next = 3;
                break;
              }

              throw new Error('exhibit: Cannot write to watched directory');

            case 3:
              if (dir._watching) {
                _context6.next = 6;
                break;
              }

              _context6.next = 6;
              return reprime(dir);

            case 6:

              // see what changes are needed
              patch = (0, _diff2.default)(dir._files, incomingFiles);

              // start some mutatable objects based on our existing caches (eventually to replace them)

              newFiles = dir._files.toObject();
              newMtimes = dir._mtimes.toObject();

              // note deleted paths (so we can prune empty dirs after deleting the files)

              deletions = new _set2.default();

              // go through all patch paths in parallel

              _context6.next = 12;
              return _bluebird2.default.map(patch.keys(), function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(name) {
                  var contents;
                  return _regenerator2.default.wrap(function _callee5$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          contents = patch.get(name);

                          if (!(contents === null)) {
                            _context5.next = 8;
                            break;
                          }

                          // the patch says we should delete this file.
                          deletions.add(name);
                          delete newFiles[name];
                          _context5.next = 6;
                          return _sander2.default.unlink(dir._absolutePath, name);

                        case 6:
                          _context5.next = 12;
                          break;

                        case 8:
                          _context5.next = 10;
                          return _sander2.default.writeFile(dir._absolutePath, name, contents);

                        case 10:

                          // then set our new caches
                          newMtimes[name] = Date.now(); // nb. must record time after writing, not before
                          newFiles[name] = contents;

                        case 12:
                        case 'end':
                          return _context5.stop();
                      }
                    }
                  }, _callee5, _this3);
                }));
                return function (_x5) {
                  return ref.apply(this, arguments);
                };
              }());

            case 12:

              // now all files are deleted, prune any empty directories in series
              _iteratorNormalCompletion2 = true;
              _didIteratorError2 = false;
              _iteratorError2 = undefined;
              _context6.prev = 15;
              _iterator2 = (0, _getIterator3.default)(deletions);

            case 17:
              if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                _context6.next = 24;
                break;
              }

              deletion = _step2.value;
              _context6.next = 21;
              return pruneEmptyAncestors(_path2.default.resolve(dir._absolutePath, deletion), dir._absolutePath);

            case 21:
              _iteratorNormalCompletion2 = true;
              _context6.next = 17;
              break;

            case 24:
              _context6.next = 30;
              break;

            case 26:
              _context6.prev = 26;
              _context6.t0 = _context6['catch'](15);
              _didIteratorError2 = true;
              _iteratorError2 = _context6.t0;

            case 30:
              _context6.prev = 30;
              _context6.prev = 31;

              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }

            case 33:
              _context6.prev = 33;

              if (!_didIteratorError2) {
                _context6.next = 36;
                break;
              }

              throw _iteratorError2;

            case 36:
              return _context6.finish(33);

            case 37:
              return _context6.finish(30);

            case 38:

              // update our files cache
              files = _immutable2.default.Map(newFiles);
              mtimes = _immutable2.default.Map(newMtimes);


              dir._files = files;
              dir._mtimes = mtimes;

              return _context6.abrupt('return', files);

            case 43:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, _this3, [[15, 26, 30, 38], [31,, 33, 37]]);
    }))();
  },


  /**
   * Starts watching the directory and calls your subscriber whenever things change.
   */
  watch: function watch(subscriber, saneOptions) {
    var _this4 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
      var dir, notify, onWatchEvent, watcher;
      return _regenerator2.default.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              dir = _this4;

              if (!dir._watcher) {
                _context9.next = 3;
                break;
              }

              throw new Error('Already watching');

            case 3:
              _context9.next = 5;
              return reprime(dir);

            case 5:
              notify = (0, _lodash.debounce)(function () {
                subscriber(dir._files);
              });

              onWatchEvent = function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(name, root, stat) {
                  return _regenerator2.default.wrap(function _callee7$(_context7) {
                    while (1) {
                      switch (_context7.prev = _context7.next) {
                        case 0:
                          if (dir._match(name)) {
                            _context7.next = 2;
                            break;
                          }

                          return _context7.abrupt('return');

                        case 2:
                          if (stat) {
                            _context7.next = 8;
                            break;
                          }

                          dir._files = dir._files.delete(name);
                          dir._mtimes = dir._mtimes.delete(name);
                          notify();
                          _context7.next = 17;
                          break;

                        case 8:
                          if (!stat.isFile()) {
                            _context7.next = 17;
                            break;
                          }

                          dir._mtimes = dir._mtimes.set(name, stat.mtime.getTime());
                          _context7.t0 = dir._files;
                          _context7.t1 = name;
                          _context7.next = 14;
                          return _sander2.default.readFile(root, name);

                        case 14:
                          _context7.t2 = _context7.sent;
                          dir._files = _context7.t0.set.call(_context7.t0, _context7.t1, _context7.t2);

                          notify();

                        case 17:
                        case 'end':
                          return _context7.stop();
                      }
                    }
                  }, _callee7, _this4);
                }));
                return function onWatchEvent(_x6, _x7, _x8) {
                  return ref.apply(this, arguments);
                };
              }();

              watcher = (0, _sane2.default)(dir._absolutePath, saneOptions);


              watcher.on('add', onWatchEvent);
              watcher.on('change', onWatchEvent);
              watcher.on('delete', onWatchEvent);
              dir._watcher = watcher;

              return _context9.abrupt('return', new _bluebird2.default(function (resolve, reject) {
                watcher.on('error', reject);

                watcher.on('ready', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8() {
                  return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                      switch (_context8.prev = _context8.next) {
                        case 0:
                          _context8.next = 2;
                          return reprime(dir);

                        case 2:
                          notify();
                          resolve();

                        case 4:
                        case 'end':
                          return _context8.stop();
                      }
                    }
                  }, _callee8, _this4);
                })));
              }));

            case 13:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee9, _this4);
    }))();
  },


  /**
   * Starts a simple dev server.
   */
  serve: function serve() {
    var _this5 = this;

    return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
      var dir, _ref, _ref2, serverPort, app, server;

      return _regenerator2.default.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              dir = _this5;
              _context10.next = 3;
              return (0, _portscannerPlus.getPorts)(1, 8000, 9000);

            case 3:
              _ref = _context10.sent;
              _ref2 = (0, _slicedToArray3.default)(_ref, 1);
              serverPort = _ref2[0];
              app = (0, _connect2.default)();

              app.use((0, _serveStatic2.default)(dir._absolutePath));
              app.use((0, _errorhandler2.default)());
              app.use((0, _serveIndex2.default)(dir._absolutePath, { icons: true, hidden: true, view: 'details' }));

              server = _http2.default.createServer(app);
              _context10.next = 13;
              return (0, _bluebird.promisify)(server.listen.bind(server))(serverPort);

            case 13:

              console.log('Serving ' + _path2.default.relative(process.cwd(), dir._absolutePath) + ' at http://localhost:' + serverPort + '/');

            case 14:
            case 'end':
              return _context10.stop();
          }
        }
      }, _callee10, _this5);
    }))();
  }
};

/**
 * Main public interface: a convenience function for making a new instance
 * (with some path-joining sugar).
 */
function directory() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var options = typeof args[args.length - 1] === 'string' ? undefined : args.pop();

  return new Directory(_path2.default.resolve.apply(null, args), options);
}
//# sourceMappingURL=directory.js.map