'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = matcher;

var _micromatch = require('micromatch');

var _micromatch2 = _interopRequireDefault(_micromatch);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var alwaysTrue = function alwaysTrue() {
  return true;
};
var alwaysFalse = function alwaysFalse() {
  return false;
};

/**
 * Given a pattern of any kind, returns a function that can be used repeatedly
 * to check file paths against that pattern.
 */
function matcher(pattern) {
  if (pattern === '**' || pattern === true) return alwaysTrue;

  if ((0, _lodash.isFunction)(pattern)) return function (name) {
    return Boolean(pattern(name));
  };

  if ((0, _lodash.isRegExp)(pattern)) return function (name) {
    return pattern.test(name);
  };

  if (!pattern) return alwaysFalse;

  return _micromatch2.default.filter(pattern);
}
//# sourceMappingURL=matcher.js.map